package controller

import (
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/config"
	v1 "gitlab.bit9.local/psc/platform/ems/device-service/internal/controller/v1"
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/service"

	"github.com/labstack/echo/v4"
	"github.com/spf13/viper"
)

func Route(echoServer *echo.Echo, svc service.Performer, rdyChkr service.ReadinessChecker) {
	root := echoServer.Group(viper.GetString(config.WebRoutesPrefixKey))

	// Health-check route
	root.GET(config.HealthCheckPath, CreateHealthCheck(rdyChkr))

	// V1 routes
	v1Group := root.Group("/v1")
	v1Group.POST("", v1.CreatePOSTRootHandler(svc))
}
