package v1

import (
	"fmt"
	"net/http"

	"gitlab.bit9.local/psc/platform/ems/device-service/internal/service"

	"github.com/labstack/echo/v4"
	"github.com/rs/zerolog"
)

func CreatePOSTRootHandler(svc service.Performer) func(e echo.Context) error {
	return func(ctx echo.Context) error {
		logger := zerolog.Ctx(ctx.Request().Context())

		if err := svc.Perform(logger); err != nil {
			return fmt.Errorf("failed to perform service: %w", err)
		}

		if err := ctx.NoContent(http.StatusAccepted); err != nil {
			return fmt.Errorf("failed to render v1 response: %w", err)
		}

		return nil
	}
}
