package data

import (
	"context"

	"github.com/aws/aws-sdk-go-v2/aws"
	awscfg "github.com/aws/aws-sdk-go-v2/config"
	"github.com/rs/zerolog/log"
)

func getAWSConfig() aws.Config {
	cfg, err := awscfg.LoadDefaultConfig(context.Background())
	if err != nil {
		log.Err(err).Msg("getAWSConfig: unable to load aws SDK config")
		panic(err)
	}

	return cfg
}
