package data

import (
	"github.com/spf13/viper"
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/config"
)

const (
	partitionKey = "partitionKey"
	sortKey      = "sortKey"
)

type TableSpecs struct {
	TableName             string
	compositeKeySeparator string
	partitionKeys         []string
	sortKeys              []string
}

// DeviceTableSpecs returns a pointer to the device table spec struct.
//
//nolint:godox // reminder to finalize keys
func DeviceTableSpecs() *TableSpecs {
	return &TableSpecs{
		TableName:             viper.GetString(config.DeviceTableNameKey),
		compositeKeySeparator: "_",
		partitionKeys:         []string{"RegistrationID", "DeviceGUID"}, // TODO: determine appropriate keys.
		sortKeys:              []string{"LastUpdateTime"},               // TODO: determine appropriate keys.
	}
}
