package middleware

import (
	"github.com/labstack/echo/v4"
	"github.com/labstack/echo/v4/middleware"
	"github.com/rs/zerolog"
)

func Recover() echo.MiddlewareFunc {
	//nolint:exhaustruct // just need override for LogErrorFunc, defaults/nil ok for other
	return middleware.RecoverWithConfig(middleware.RecoverConfig{
		LogErrorFunc: recoverLogError,
	})
}

func recoverLogError(echoCtx echo.Context, err error, stack []byte) error {
	logger := zerolog.Ctx(echoCtx.Request().Context())
	logger.Err(err).Str("stack", string(stack)).Msg("[PANIC RECOVER]")

	return err
}
