package middleware

import (
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/config"

	"github.com/google/uuid"
	"github.com/labstack/echo/v4"
	"github.com/labstack/echo/v4/middleware"
	"github.com/rs/zerolog"
	"github.com/spf13/viper"
)

func handleRequestID(echoCtx echo.Context, requestID string) {
	ctx := echoCtx.Request().Context()
	logger := *zerolog.Ctx(ctx)
	ctx = logger.With().Str("request_id", requestID).Logger().WithContext(ctx)

	echoCtx.SetRequest(echoCtx.Request().WithContext(ctx))
}

func RequestID() echo.MiddlewareFunc {
	//nolint: exhaustruct // only need to override RequestIDConfig defaults
	return middleware.RequestIDWithConfig(middleware.RequestIDConfig{
		TargetHeader:     viper.GetString(config.HTTPRequestIDHeaderKey),
		Generator:        uuid.New().String,
		RequestIDHandler: handleRequestID,
	})
}
