//nolint:testpackage // testing internal enums
package model

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

//nolint:lll // long url, sorry
// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
//
//   XP(5, "Windows_XP", SensorKitType.XP),
//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
//   OSX(10, "MAC OS X", SensorKitType.MAC),
//   OS11(11, "MAC OS 11", SensorKitType.MAC),
//   OS12(12, "MAC OS 12", SensorKitType.MAC),
//   OS13(13, "MAC OS 13", SensorKitType.MAC),
//   OS14(14, "MAC OS 14", SensorKitType.MAC),
//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
//   UNKNOWN(21, "Unknown", null);

var _ = Describe("OS Major Enum", func() {
	It("should have the correct values", func() {
		Expect(osMajorXP).To(BeEquivalentTo(5))
		Expect(osMajorWindows).To(BeEquivalentTo(6))
		Expect(osMajorMacOSX).To(BeEquivalentTo(10))
		Expect(osMajorMacOS11).To(BeEquivalentTo(11))
		Expect(osMajorMacOS12).To(BeEquivalentTo(12))
		Expect(osMajorMacOS13).To(BeEquivalentTo(13))
		Expect(osMajorMacOS14).To(BeEquivalentTo(14))
		Expect(osMajorWindows10).To(BeEquivalentTo(1010))
		Expect(osMajorWindows11).To(BeEquivalentTo(1011))
		Expect(osMajorUnknownRHEL).To(BeEquivalentTo(2000))
		Expect(osMajorUnknownUbuntu).To(BeEquivalentTo(2001))
		Expect(osMajorUnknownSUSE).To(BeEquivalentTo(2002))
		Expect(osMajorUnknownAmazonLinux).To(BeEquivalentTo(2003))
		Expect(osMajorUnknownGoogleLinux).To(BeEquivalentTo(2004))
		Expect(osMajorCentOS6).To(BeEquivalentTo(2106))
		Expect(osMajorCentOS7).To(BeEquivalentTo(2107))
		Expect(osMajorCentOS8).To(BeEquivalentTo(2108))
		Expect(osMajorCentOS9).To(BeEquivalentTo(2109))
		Expect(osMajorRHEL6).To(BeEquivalentTo(2206))
		Expect(osMajorRHEL7).To(BeEquivalentTo(2207))
		Expect(osMajorRHEL8).To(BeEquivalentTo(2208))
		Expect(osMajorRHEL9).To(BeEquivalentTo(2209))
		Expect(osMajorUbuntu12).To(BeEquivalentTo(2312))
		Expect(osMajorUbuntu14).To(BeEquivalentTo(2314))
		Expect(osMajorUbuntu16).To(BeEquivalentTo(2316))
		Expect(osMajorUbuntu18).To(BeEquivalentTo(2318))
		Expect(osMajorUbuntu19).To(BeEquivalentTo(2319))
		Expect(osMajorUbuntu20).To(BeEquivalentTo(2320))
		Expect(osMajorUbuntu21).To(BeEquivalentTo(2321))
		Expect(osMajorUbuntu22).To(BeEquivalentTo(2322))
		Expect(osMajorSLES12).To(BeEquivalentTo(2412))
		Expect(osMajorSLES15).To(BeEquivalentTo(2415))
		Expect(osMajorSLES16).To(BeEquivalentTo(2416))
		Expect(osMajorSLES17).To(BeEquivalentTo(2417))
		Expect(osMajorAmazonLinux2).To(BeEquivalentTo(2502))
		Expect(osMajorAmazonLinux3).To(BeEquivalentTo(2503))
		Expect(osMajorAmazonLinux2023).To(BeEquivalentTo(2523))
		Expect(osMajorOpenSUSELeap15).To(BeEquivalentTo(2615))
		Expect(osMajorOpenSUSELeap42).To(BeEquivalentTo(2642))
		Expect(osMajorDebian8).To(BeEquivalentTo(2708))
		Expect(osMajorDebian9).To(BeEquivalentTo(2709))
		Expect(osMajorDebian10).To(BeEquivalentTo(2710))
		Expect(osMajorDebian11).To(BeEquivalentTo(2711))
		Expect(osMajorOracle6).To(BeEquivalentTo(2806))
		Expect(osMajorOracle7).To(BeEquivalentTo(2807))
		Expect(osMajorOracle8).To(BeEquivalentTo(2808))
		Expect(osMajorOracle9).To(BeEquivalentTo(2809))
		Expect(osMajorGoogleContainerOptimized).To(BeEquivalentTo(2900))
		Expect(osMajorVMwareESXi8).To(BeEquivalentTo(3008))
		Expect(osMajorAlma8).To(BeEquivalentTo(3108))
		Expect(osMajorAlma9).To(BeEquivalentTo(3109))
		Expect(osMajorRocky8).To(BeEquivalentTo(3208))
		Expect(osMajorRocky9).To(BeEquivalentTo(3209))
		Expect(osMajorUnknown).To(BeEquivalentTo(21))
	})
})
