//nolint:nlreturn // test file, brevity
package model //nolint:testpackage // testing internal enums

import (
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

var _ = Describe("OS Version", func() {
	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/WinOsxDeviceStatusRequest.java
	//
	// aMap.put("151", "XP x86");
	// aMap.put("352", "Server 2003 x86");
	// aMap.put("160", "Vista x86");
	// aMap.put("260", "Vista x64");
	// aMap.put("360", "Server 2008 x86");
	// aMap.put("460", "Server 2008 x64");
	// aMap.put("461", "Server 2008 R2 x64");
	// aMap.put("161", "Windows 7 x86");
	// aMap.put("261", "Windows 7 x64");
	// aMap.put("462", "Server 2012 x64");
	// aMap.put("162", "Windows 8 x86");
	// aMap.put("262", "Windows 8 x64");
	// aMap.put("463", "Server 2012 R2 x64");
	// aMap.put("163", "Windows 8.1 x86");
	// aMap.put("263", "Windows 8.1 x64");
	// aMap.put("110100", "Windows 10 x86");
	// aMap.put("210100", "Windows 10 x64");
	// aMap.put("410100", "Windows Server 2016 x64");
	// aMap.put("510100", "Windows 10 arm64");
	// aMap.put("610100", "Windows Server arm64");
	// aMap.put("210110", "Windows 11 x64");
	// aMap.put("410110", "Windows Server 2022 x64");
	// aMap.put("510110", "Windows 11 arm64");

	It("should return map constant from windowsVersion func", func() {
		vers := windowsVersions()

		Expect(vers[platformEnum(1)][osMajorEnum(5)]["1"]).To(Equal("XP x86"))
		Expect(vers[platformEnum(3)][osMajorEnum(5)]["2"]).To(Equal("Server 2003 x86"))
		Expect(vers[platformEnum(1)][osMajorEnum(6)]["0"]).To(Equal("Vista x86"))
		Expect(vers[platformEnum(2)][osMajorEnum(6)]["0"]).To(Equal("Vista x64"))
		Expect(vers[platformEnum(3)][osMajorEnum(6)]["0"]).To(Equal("Server 2008 x86"))
		Expect(vers[platformEnum(4)][osMajorEnum(6)]["0"]).To(Equal("Server 2008 x64"))
		Expect(vers[platformEnum(4)][osMajorEnum(6)]["1"]).To(Equal("Server 2008 R2 x64"))
		Expect(vers[platformEnum(1)][osMajorEnum(6)]["1"]).To(Equal("Windows 7 x86"))
		Expect(vers[platformEnum(2)][osMajorEnum(6)]["1"]).To(Equal("Windows 7 x64"))
		Expect(vers[platformEnum(4)][osMajorEnum(6)]["2"]).To(Equal("Server 2012 x64"))
		Expect(vers[platformEnum(1)][osMajorEnum(6)]["2"]).To(Equal("Windows 8 x86"))
		Expect(vers[platformEnum(2)][osMajorEnum(6)]["2"]).To(Equal("Windows 8 x64"))
		Expect(vers[platformEnum(4)][osMajorEnum(6)]["3"]).To(Equal("Server 2012 R2 x64"))
		Expect(vers[platformEnum(1)][osMajorEnum(6)]["3"]).To(Equal("Windows 8.1 x86"))
		Expect(vers[platformEnum(2)][osMajorEnum(6)]["3"]).To(Equal("Windows 8.1 x64"))
		Expect(vers[platformEnum(1)][osMajorEnum(1010)]["0"]).To(Equal("Windows 10 x86"))
		Expect(vers[platformEnum(2)][osMajorEnum(1010)]["0"]).To(Equal("Windows 10 x64"))
		Expect(vers[platformEnum(4)][osMajorEnum(1010)]["0"]).To(Equal("Windows Server 2016 x64"))
		Expect(vers[platformEnum(5)][osMajorEnum(1010)]["0"]).To(Equal("Windows 10 arm64"))
		Expect(vers[platformEnum(6)][osMajorEnum(1010)]["0"]).To(Equal("Windows Server arm64"))
		Expect(vers[platformEnum(2)][osMajorEnum(1011)]["0"]).To(Equal("Windows 11 x64"))
		Expect(vers[platformEnum(4)][osMajorEnum(1011)]["0"]).To(Equal("Windows Server 2022 x64"))
		Expect(vers[platformEnum(5)][osMajorEnum(1011)]["0"]).To(Equal("Windows 11 arm64"))
	})

	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
	//
	//   XP(5, "Windows_XP", SensorKitType.XP),
	//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
	//   OSX(10, "MAC OS X", SensorKitType.MAC),
	//   OS11(11, "MAC OS 11", SensorKitType.MAC),
	//   OS12(12, "MAC OS 12", SensorKitType.MAC),
	//   OS13(13, "MAC OS 13", SensorKitType.MAC),
	//   OS14(14, "MAC OS 14", SensorKitType.MAC),
	//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
	//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
	//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
	//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
	//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
	//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
	//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
	//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
	//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
	//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
	//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
	//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
	//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
	//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
	//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
	//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
	//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
	//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
	//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
	//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
	//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
	//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
	//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
	//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
	//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
	//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
	//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
	//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
	//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
	//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
	//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
	//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
	//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
	//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
	//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
	//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
	//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
	//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
	//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
	//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
	//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
	//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
	//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
	//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
	//   UNKNOWN(21, "Unknown", null);

	It("should return map constant from representations func", func() {
		reps := representations()

		Expect(reps).To(HaveKeyWithValue(osMajorXP, "Windows_XP"))
		Expect(reps).To(HaveKeyWithValue(osMajorWindows, "Windows"))
		Expect(reps).To(HaveKeyWithValue(osMajorMacOSX, "MAC OS X 10"))
		Expect(reps).To(HaveKeyWithValue(osMajorMacOS11, "MAC OS 11"))
		Expect(reps).To(HaveKeyWithValue(osMajorMacOS12, "MAC OS 12"))
		Expect(reps).To(HaveKeyWithValue(osMajorMacOS13, "MAC OS 13"))
		Expect(reps).To(HaveKeyWithValue(osMajorMacOS14, "MAC OS 14"))
		Expect(reps).To(HaveKeyWithValue(osMajorWindows10, "Windows 10"))
		Expect(reps).To(HaveKeyWithValue(osMajorWindows11, "Windows 11"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknownRHEL, "Linux (Unsupported)"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknownUbuntu, "Linux (Unsupported)"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknownSUSE, "Linux (Unsupported)"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknownAmazonLinux, "Linux (Unsupported)"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknownGoogleLinux, "Linux (Unsupported)"))
		Expect(reps).To(HaveKeyWithValue(osMajorCentOS6, "CentOS 6"))
		Expect(reps).To(HaveKeyWithValue(osMajorCentOS7, "CentOS 7"))
		Expect(reps).To(HaveKeyWithValue(osMajorCentOS8, "CentOS 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorCentOS9, "CentOS 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorRHEL6, "RHEL 6"))
		Expect(reps).To(HaveKeyWithValue(osMajorRHEL7, "RHEL 7"))
		Expect(reps).To(HaveKeyWithValue(osMajorRHEL8, "RHEL 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorRHEL9, "RHEL 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu12, "Ubuntu 12"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu14, "Ubuntu 14"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu16, "Ubuntu 16"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu18, "Ubuntu 18"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu19, "Ubuntu 19"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu20, "Ubuntu 20"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu21, "Ubuntu 21"))
		Expect(reps).To(HaveKeyWithValue(osMajorUbuntu22, "Ubuntu 22"))
		Expect(reps).To(HaveKeyWithValue(osMajorSLES12, "SLES 12"))
		Expect(reps).To(HaveKeyWithValue(osMajorSLES15, "SLES 15"))
		Expect(reps).To(HaveKeyWithValue(osMajorSLES16, "SLES 16"))
		Expect(reps).To(HaveKeyWithValue(osMajorSLES17, "SLES 17"))
		Expect(reps).To(HaveKeyWithValue(osMajorAmazonLinux2, "Amazon Linux 2"))
		Expect(reps).To(HaveKeyWithValue(osMajorAmazonLinux3, "Amazon Linux 3"))
		Expect(reps).To(HaveKeyWithValue(osMajorAmazonLinux2023, "Amazon Linux 2023"))
		Expect(reps).To(HaveKeyWithValue(osMajorOpenSUSELeap15, "OpenSUSE Leap 15"))
		Expect(reps).To(HaveKeyWithValue(osMajorOpenSUSELeap42, "OpenSUSE Leap 42"))
		Expect(reps).To(HaveKeyWithValue(osMajorDebian8, "Debian 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorDebian9, "Debian 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorDebian10, "Debian 10"))
		Expect(reps).To(HaveKeyWithValue(osMajorDebian11, "Debian 11"))
		Expect(reps).To(HaveKeyWithValue(osMajorOracle6, "Oracle 6"))
		Expect(reps).To(HaveKeyWithValue(osMajorOracle7, "Oracle 7"))
		Expect(reps).To(HaveKeyWithValue(osMajorOracle8, "Oracle 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorOracle9, "Oracle 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorGoogleContainerOptimized, "Google Container-Optimized"))
		Expect(reps).To(HaveKeyWithValue(osMajorVMwareESXi8, "VMware ESXi 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorAlma8, "Alma Linux 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorAlma9, "Alma Linux 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorRocky8, "Rocky Linux 8"))
		Expect(reps).To(HaveKeyWithValue(osMajorRocky9, "Rocky Linux 9"))
		Expect(reps).To(HaveKeyWithValue(osMajorUnknown, "Unknown"))
	})

	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
	//
	//   XP(5, "Windows_XP", SensorKitType.XP),
	//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
	//   OSX(10, "MAC OS X", SensorKitType.MAC),
	//   OS11(11, "MAC OS 11", SensorKitType.MAC),
	//   OS12(12, "MAC OS 12", SensorKitType.MAC),
	//   OS13(13, "MAC OS 13", SensorKitType.MAC),
	//   OS14(14, "MAC OS 14", SensorKitType.MAC),
	//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
	//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
	//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
	//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
	//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
	//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
	//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
	//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
	//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
	//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
	//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
	//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
	//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
	//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
	//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
	//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
	//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
	//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
	//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
	//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
	//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
	//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
	//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
	//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
	//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
	//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
	//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
	//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
	//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
	//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
	//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
	//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
	//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
	//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
	//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
	//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
	//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
	//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
	//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
	//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
	//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
	//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
	//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
	//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
	//   UNKNOWN(21, "Unknown", null);

	//nolint:dupl // no dupls here
	It("should return representation from osRepresentation function", func() {
		Expect(osRepresentation("5")).To(Equal("Windows_XP"))
		Expect(osRepresentation("6")).To(Equal("Windows"))
		Expect(osRepresentation("10")).To(Equal("MAC OS X 10"))
		Expect(osRepresentation("11")).To(Equal("MAC OS 11"))
		Expect(osRepresentation("12")).To(Equal("MAC OS 12"))
		Expect(osRepresentation("13")).To(Equal("MAC OS 13"))
		Expect(osRepresentation("14")).To(Equal("MAC OS 14"))
		Expect(osRepresentation("1010")).To(Equal("Windows 10"))
		Expect(osRepresentation("1011")).To(Equal("Windows 11"))
		Expect(osRepresentation("2000")).To(Equal("Linux (Unsupported)"))
		Expect(osRepresentation("2001")).To(Equal("Linux (Unsupported)"))
		Expect(osRepresentation("2002")).To(Equal("Linux (Unsupported)"))
		Expect(osRepresentation("2003")).To(Equal("Linux (Unsupported)"))
		Expect(osRepresentation("2004")).To(Equal("Linux (Unsupported)"))
		Expect(osRepresentation("2106")).To(Equal("CentOS 6"))
		Expect(osRepresentation("2107")).To(Equal("CentOS 7"))
		Expect(osRepresentation("2108")).To(Equal("CentOS 8"))
		Expect(osRepresentation("2109")).To(Equal("CentOS 9"))
		Expect(osRepresentation("2206")).To(Equal("RHEL 6"))
		Expect(osRepresentation("2207")).To(Equal("RHEL 7"))
		Expect(osRepresentation("2208")).To(Equal("RHEL 8"))
		Expect(osRepresentation("2209")).To(Equal("RHEL 9"))
		Expect(osRepresentation("2312")).To(Equal("Ubuntu 12"))
		Expect(osRepresentation("2314")).To(Equal("Ubuntu 14"))
		Expect(osRepresentation("2316")).To(Equal("Ubuntu 16"))
		Expect(osRepresentation("2318")).To(Equal("Ubuntu 18"))
		Expect(osRepresentation("2319")).To(Equal("Ubuntu 19"))
		Expect(osRepresentation("2320")).To(Equal("Ubuntu 20"))
		Expect(osRepresentation("2321")).To(Equal("Ubuntu 21"))
		Expect(osRepresentation("2322")).To(Equal("Ubuntu 22"))
		Expect(osRepresentation("2412")).To(Equal("SLES 12"))
		Expect(osRepresentation("2415")).To(Equal("SLES 15"))
		Expect(osRepresentation("2416")).To(Equal("SLES 16"))
		Expect(osRepresentation("2417")).To(Equal("SLES 17"))
		Expect(osRepresentation("2502")).To(Equal("Amazon Linux 2"))
		Expect(osRepresentation("2503")).To(Equal("Amazon Linux 3"))
		Expect(osRepresentation("2523")).To(Equal("Amazon Linux 2023"))
		Expect(osRepresentation("2615")).To(Equal("OpenSUSE Leap 15"))
		Expect(osRepresentation("2642")).To(Equal("OpenSUSE Leap 42"))
		Expect(osRepresentation("2708")).To(Equal("Debian 8"))
		Expect(osRepresentation("2709")).To(Equal("Debian 9"))
		Expect(osRepresentation("2710")).To(Equal("Debian 10"))
		Expect(osRepresentation("2711")).To(Equal("Debian 11"))
		Expect(osRepresentation("2806")).To(Equal("Oracle 6"))
		Expect(osRepresentation("2807")).To(Equal("Oracle 7"))
		Expect(osRepresentation("2808")).To(Equal("Oracle 8"))
		Expect(osRepresentation("2809")).To(Equal("Oracle 9"))
		Expect(osRepresentation("2900")).To(Equal("Google Container-Optimized"))
		Expect(osRepresentation("3008")).To(Equal("VMware ESXi 8"))
		Expect(osRepresentation("3108")).To(Equal("Alma Linux 8"))
		Expect(osRepresentation("3109")).To(Equal("Alma Linux 9"))
		Expect(osRepresentation("3208")).To(Equal("Rocky Linux 8"))
		Expect(osRepresentation("3209")).To(Equal("Rocky Linux 9"))
		Expect(osRepresentation("21")).To(Equal("Unknown"))
		Expect(osRepresentation("99999")).To(Equal("Unknown"))
		Expect(osRepresentation("")).To(Equal(""))
		Expect(osRepresentation("abc")).To(Equal(""))
	})

	It("should have mac kits", func() {
		kits := macKits()

		Expect(kits).To(HaveKeyWithValue(sensorKitMac, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitMacOSX, true))
		Expect(kits).To(HaveLen(2))
	})

	It("should have linux kits", func() {
		kits := linuxKits()

		Expect(kits).To(HaveKeyWithValue(sensorKitAmazonLinux, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitGoogleLinux, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitRHEL, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitSUSE, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitUbuntu, true))
		Expect(kits).To(HaveLen(5))
	})

	It("should have windows kits", func() {
		kits := windowsKits()

		Expect(kits).To(HaveKeyWithValue(sensorKitWindows, true))
		Expect(kits).To(HaveKeyWithValue(sensorKitXP, true))
		Expect(kits).To(HaveLen(2))
	})

	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
	//
	//   XP(5, "Windows_XP", SensorKitType.XP),
	//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
	//   OSX(10, "MAC OS X", SensorKitType.MAC),
	//   OS11(11, "MAC OS 11", SensorKitType.MAC),
	//   OS12(12, "MAC OS 12", SensorKitType.MAC),
	//   OS13(13, "MAC OS 13", SensorKitType.MAC),
	//   OS14(14, "MAC OS 14", SensorKitType.MAC),
	//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
	//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
	//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
	//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
	//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
	//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
	//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
	//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
	//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
	//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
	//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
	//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
	//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
	//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
	//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
	//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
	//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
	//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
	//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
	//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
	//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
	//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
	//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
	//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
	//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
	//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
	//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
	//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
	//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
	//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
	//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
	//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
	//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
	//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
	//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
	//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
	//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
	//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
	//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
	//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
	//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
	//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
	//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
	//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
	//   UNKNOWN(21, "Unknown", null);

	It("should have sensor kits", func() {
		kits := sensorKits()

		Expect(kits).To(HaveKeyWithValue(osMajorXP, sensorKitXP))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOSX, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS11, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS12, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS13, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS14, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows10, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows11, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownRHEL, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownUbuntu, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownSUSE, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownAmazonLinux, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownGoogleLinux, sensorKitGoogleLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu12, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu14, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu16, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu18, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu19, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu20, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu21, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu22, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES12, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES15, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES16, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES17, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux2, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux3, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux2023, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorOpenSUSELeap15, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorOpenSUSELeap42, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian8, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian9, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian10, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian11, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorGoogleContainerOptimized, sensorKitGoogleLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorVMwareESXi8, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorAlma8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorAlma9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRocky8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRocky9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknown, sensorKitEnum(0)))
		Expect(kits).To(HaveLen(54))
	})

	It("should have unknown linux versions", func() {
		vers := unknownLinuxVersions()

		Expect(vers).To(HaveKeyWithValue(osMajorUnknownAmazonLinux, true))
		Expect(vers).To(HaveKeyWithValue(osMajorUnknownGoogleLinux, true))
		Expect(vers).To(HaveKeyWithValue(osMajorUnknownRHEL, true))
		Expect(vers).To(HaveKeyWithValue(osMajorUnknownSUSE, true))
		Expect(vers).To(HaveKeyWithValue(osMajorUnknownUbuntu, true))
		Expect(vers).To(HaveLen(5))
	})

	It("should have sles linux versions", func() {
		vers := slesLinuxVersions()

		Expect(vers).To(HaveKeyWithValue(osMajorSLES12, true))
		Expect(vers).To(HaveKeyWithValue(osMajorSLES15, true))
		Expect(vers).To(HaveKeyWithValue(osMajorSLES16, true))
		Expect(vers).To(HaveKeyWithValue(osMajorSLES17, true))
		Expect(vers).To(HaveLen(4))
	})

	It("should have google linux versions", func() {
		vers := googleLinuxVersions()

		Expect(vers).To(HaveKeyWithValue(osMajorUnknownGoogleLinux, true))
		Expect(vers).To(HaveKeyWithValue(osMajorGoogleContainerOptimized, true))
		Expect(vers).To(HaveLen(2))
	})

	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
	//
	//   XP(5, "Windows_XP", SensorKitType.XP),
	//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
	//   OSX(10, "MAC OS X", SensorKitType.MAC),
	//   OS11(11, "MAC OS 11", SensorKitType.MAC),
	//   OS12(12, "MAC OS 12", SensorKitType.MAC),
	//   OS13(13, "MAC OS 13", SensorKitType.MAC),
	//   OS14(14, "MAC OS 14", SensorKitType.MAC),
	//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
	//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
	//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
	//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
	//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
	//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
	//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
	//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
	//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
	//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
	//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
	//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
	//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
	//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
	//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
	//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
	//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
	//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
	//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
	//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
	//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
	//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
	//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
	//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
	//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
	//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
	//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
	//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
	//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
	//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
	//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
	//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
	//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
	//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
	//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
	//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
	//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
	//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
	//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
	//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
	//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
	//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
	//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
	//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
	//   UNKNOWN(21, "Unknown", null);

	//nolint:dupl // no dupls here
	It("should return sensor kit string", func() {
		Expect(sensorKit("5")).To(Equal("XP"))
		Expect(sensorKit("6")).To(Equal("WINDOWS"))
		Expect(sensorKit("10")).To(Equal("MAC"))
		Expect(sensorKit("11")).To(Equal("MAC"))
		Expect(sensorKit("12")).To(Equal("MAC"))
		Expect(sensorKit("13")).To(Equal("MAC"))
		Expect(sensorKit("14")).To(Equal("MAC"))
		Expect(sensorKit("1010")).To(Equal("WINDOWS"))
		Expect(sensorKit("1011")).To(Equal("WINDOWS"))
		Expect(sensorKit("2000")).To(Equal("RHEL"))
		Expect(sensorKit("2001")).To(Equal("UBUNTU"))
		Expect(sensorKit("2002")).To(Equal("SUSE"))
		Expect(sensorKit("2003")).To(Equal("AMAZON_LINUX"))
		Expect(sensorKit("2004")).To(Equal("GOOGLE_LINUX"))
		Expect(sensorKit("2106")).To(Equal("RHEL"))
		Expect(sensorKit("2107")).To(Equal("RHEL"))
		Expect(sensorKit("2108")).To(Equal("RHEL"))
		Expect(sensorKit("2109")).To(Equal("RHEL"))
		Expect(sensorKit("2206")).To(Equal("RHEL"))
		Expect(sensorKit("2207")).To(Equal("RHEL"))
		Expect(sensorKit("2208")).To(Equal("RHEL"))
		Expect(sensorKit("2209")).To(Equal("RHEL"))
		Expect(sensorKit("2312")).To(Equal("UBUNTU"))
		Expect(sensorKit("2314")).To(Equal("UBUNTU"))
		Expect(sensorKit("2316")).To(Equal("UBUNTU"))
		Expect(sensorKit("2318")).To(Equal("UBUNTU"))
		Expect(sensorKit("2319")).To(Equal("UBUNTU"))
		Expect(sensorKit("2320")).To(Equal("UBUNTU"))
		Expect(sensorKit("2321")).To(Equal("UBUNTU"))
		Expect(sensorKit("2322")).To(Equal("UBUNTU"))
		Expect(sensorKit("2412")).To(Equal("SUSE"))
		Expect(sensorKit("2415")).To(Equal("SUSE"))
		Expect(sensorKit("2416")).To(Equal("SUSE"))
		Expect(sensorKit("2417")).To(Equal("SUSE"))
		Expect(sensorKit("2502")).To(Equal("AMAZON_LINUX"))
		Expect(sensorKit("2503")).To(Equal("AMAZON_LINUX"))
		Expect(sensorKit("2523")).To(Equal("AMAZON_LINUX"))
		Expect(sensorKit("2615")).To(Equal("SUSE"))
		Expect(sensorKit("2642")).To(Equal("SUSE"))
		Expect(sensorKit("2708")).To(Equal("UBUNTU"))
		Expect(sensorKit("2709")).To(Equal("UBUNTU"))
		Expect(sensorKit("2710")).To(Equal("UBUNTU"))
		Expect(sensorKit("2711")).To(Equal("UBUNTU"))
		Expect(sensorKit("2806")).To(Equal("RHEL"))
		Expect(sensorKit("2807")).To(Equal("RHEL"))
		Expect(sensorKit("2808")).To(Equal("RHEL"))
		Expect(sensorKit("2809")).To(Equal("RHEL"))
		Expect(sensorKit("2900")).To(Equal("GOOGLE_LINUX"))
		Expect(sensorKit("3008")).To(Equal("SUSE"))
		Expect(sensorKit("3108")).To(Equal("RHEL"))
		Expect(sensorKit("3109")).To(Equal("RHEL"))
		Expect(sensorKit("3208")).To(Equal("RHEL"))
		Expect(sensorKit("3209")).To(Equal("RHEL"))
		Expect(sensorKit("21")).To(Equal("UNKNOWN"))
		Expect(sensorKit("99999")).To(Equal("UNKNOWN"))
		Expect(sensorKit("abc")).To(Equal(""))
		Expect(sensorKit("")).To(Equal(""))
	})

	It("should not return version string when given non integer inputs", func() {
		Expect(func() error { _, err := version("", "", "", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("abc", "", "", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "", "", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "abc", "", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "abc", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "abc", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "5", ""); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "5", "abc"); return err }()).ShouldNot(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "", "5"); return err }()).Should(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "abc", "5"); return err }()).Should(Succeed())
		Expect(func() error { _, err := version("2320", "abc", "5", "5", "2"); return err }()).ShouldNot(Succeed())
	})

	It("should return version string", func() {
		Expect(func() error { _, err := version("5", "5", "5", "5", "5"); return err }()).Should(Succeed())
		Expect(func() error { _, err := version("5", "5", "5", "5", "5"); return err }()).Should(Succeed())
	})

	It("should return specific version strings", func() {
		Expect(version("1010", "0", "5", "17623", "4")).To(Equal("Windows Server 2019 x64 SP: 5"))
		Expect(version("1010", "0", "5", "17622", "4")).To(Equal("Windows Server 2016 x64 SP: 5"))
		Expect(version("5", "1", "5", "5", "1")).To(Equal("XP x86 SP: 5"))
		Expect(version("1010", "0", "5", "5", "1")).To(Equal("Windows 10 x86 SP: 5"))
		Expect(version("1011", "0", "", "5", "2")).To(Equal("Windows 11 x64"))
		Expect(version("14", "1", "5", "5", "2")).To(Equal("MAC OS 14.1.5"))
		Expect(version("10", "1", "5", "5", "6")).To(Equal("MAC OS X 10.1.5"))
		Expect(version("2000", "1", "5", "5", "2")).To(Equal("Linux (Unsupported)"))
		Expect(version("2209", "1", "5", "5", "2")).To(Equal("RHEL 9.1-5 x64"))
		Expect(version("2209", "1", "", "5", "2")).To(Equal("RHEL 9.1 x64"))
		Expect(version("2320", "1", "5", "5", "2")).To(Equal("Ubuntu 20.01.5 x64"))
		Expect(version("2900", "1", "5", "5", "2")).To(Equal("Google Container-Optimized 1.5 x64"))
		Expect(version("2417", "1", "5", "5", "6")).To(Equal("SLES 17 SP1.5 arm64"))
		Expect(version("99999", "999", "99", "99", "99")).To(Equal("Unknown"))
	})

	//nolint:lll // long url, sorry
	// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WinOsxMajorVersionType.java
	//
	//   XP(5, "Windows_XP", SensorKitType.XP),
	//   WINDOWS(6, "Windows", SensorKitType.WINDOWS),
	//   OSX(10, "MAC OS X", SensorKitType.MAC),
	//   OS11(11, "MAC OS 11", SensorKitType.MAC),
	//   OS12(12, "MAC OS 12", SensorKitType.MAC),
	//   OS13(13, "MAC OS 13", SensorKitType.MAC),
	//   OS14(14, "MAC OS 14", SensorKitType.MAC),
	//   WINDOWS10(1010, "Windows 10", SensorKitType.WINDOWS),
	//   WINDOWS11(1011, "Windows 11", SensorKitType.WINDOWS),
	//   UNKNOWN_RHEL(2000, "Linux (Unsupported)", SensorKitType.RHEL),
	//   UNKNOWN_UBUNTU(2001, "Linux (Unsupported)", SensorKitType.UBUNTU),
	//   UNKNOWN_SUSE(2002, "Linux (Unsupported)", SensorKitType.SUSE),
	//   UNKNOWN_AMAZON_LINUX(2003, "Linux (Unsupported)", SensorKitType.AMAZON_LINUX),
	//   UNKNOWN_GOOGLE_LINUX(2004, "Linux (Unsupported)", SensorKitType.GOOGLE_LINUX),
	//   CENTOS6(2106, "CentOS 6", SensorKitType.RHEL),
	//   CENTOS7(2107, "CentOS 7", SensorKitType.RHEL),
	//   CENTOS8(2108, "CentOS 8", SensorKitType.RHEL),
	//   CENTOS9(2109, "CentOS 9", SensorKitType.RHEL),
	//   RHEL6(2206, "RHEL 6", SensorKitType.RHEL),
	//   RHEL7(2207, "RHEL 7", SensorKitType.RHEL),
	//   RHEL8(2208, "RHEL 8", SensorKitType.RHEL),
	//   RHEL9(2209, "RHEL 9", SensorKitType.RHEL),
	//   UBUNTU12(2312, "Ubuntu 12", SensorKitType.UBUNTU),
	//   UBUNTU14(2314, "Ubuntu 14", SensorKitType.UBUNTU),
	//   UBUNTU16(2316, "Ubuntu 16", SensorKitType.UBUNTU),
	//   UBUNTU18(2318, "Ubuntu 18", SensorKitType.UBUNTU),
	//   UBUNTU19(2319, "Ubuntu 19", SensorKitType.UBUNTU),
	//   UBUNTU20(2320, "Ubuntu 20", SensorKitType.UBUNTU),
	//   UBUNTU21(2321, "Ubuntu 21", SensorKitType.UBUNTU),
	//   UBUNTU22(2322, "Ubuntu 22", SensorKitType.UBUNTU),
	//   SUSE12(2412, "SLES 12", SensorKitType.SUSE),
	//   SUSE15(2415, "SLES 15", SensorKitType.SUSE),
	//   SUSE16(2416, "SLES 16", SensorKitType.SUSE),
	//   SUSE17(2417, "SLES 17", SensorKitType.SUSE),
	//   AMAZON_LINUX_2(2502, "Amazon Linux 2", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_3(2503, "Amazon Linux 3", SensorKitType.AMAZON_LINUX),
	//   AMAZON_LINUX_2023(2523, "Amazon Linux 2023", SensorKitType.AMAZON_LINUX),
	//   OPENSUSE15(2615, "OpenSUSE Leap 15", SensorKitType.SUSE),
	//   OPENSUSE42(2642, "OpenSUSE Leap 42", SensorKitType.SUSE),
	//   DEBIAN8(2708, "Debian 8", SensorKitType.UBUNTU),
	//   DEBIAN9(2709, "Debian 9", SensorKitType.UBUNTU),
	//   DEBIAN10(2710, "Debian 10", SensorKitType.UBUNTU),
	//   DEBIAN11(2711, "Debian 11", SensorKitType.UBUNTU),
	//   ORACLE6(2806, "Oracle 6", SensorKitType.RHEL),
	//   ORACLE7(2807, "Oracle 7", SensorKitType.RHEL),
	//   ORACLE8(2808, "Oracle 8", SensorKitType.RHEL),
	//   ORACLE9(2809, "Oracle 9", SensorKitType.RHEL),
	//   GOOGLE_COS(2900, "Google Container-Optimized", SensorKitType.GOOGLE_LINUX),
	//   ESXI_8(3008, "VMware ESXi 8", SensorKitType.SUSE),
	//   ALMA_LINUX_8(3108, "Alma Linux 8", SensorKitType.RHEL),
	//   ALMA_LINUX_9(3109, "Alma Linux 9", SensorKitType.RHEL),
	//   ROCKY_LINUX_8(3208, "Rocky Linux 8", SensorKitType.RHEL),
	//   ROCKY_LINUX_9(3209, "Rocky Linux 9", SensorKitType.RHEL),
	//   UNKNOWN(21, "Unknown", null);

	It("should match cbd sensor kits map", func() {
		kits := sensorKits()

		Expect(kits).To(HaveKeyWithValue(osMajorXP, sensorKitXP))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOSX, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS11, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS12, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS13, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorMacOS14, sensorKitMac))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows10, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorWindows11, sensorKitWindows))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownRHEL, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownUbuntu, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownSUSE, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownAmazonLinux, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknownGoogleLinux, sensorKitGoogleLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorCentOS9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRHEL9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu12, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu14, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu16, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu18, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu19, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu20, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu21, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorUbuntu22, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES12, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES15, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES16, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorSLES17, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux2, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux3, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorAmazonLinux2023, sensorKitAmazonLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorOpenSUSELeap15, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorOpenSUSELeap42, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian8, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian9, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian10, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorDebian11, sensorKitUbuntu))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle6, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle7, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorOracle9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorGoogleContainerOptimized, sensorKitGoogleLinux))
		Expect(kits).To(HaveKeyWithValue(osMajorVMwareESXi8, sensorKitSUSE))
		Expect(kits).To(HaveKeyWithValue(osMajorAlma8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorAlma9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRocky8, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorRocky9, sensorKitRHEL))
		Expect(kits).To(HaveKeyWithValue(osMajorUnknown, sensorKitEnum(0)))
	})
})
