//nolint:testpackage // testing internal enums
package model

import (
	"fmt"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

//nolint:lll // long url, sorry
// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/WindowsPlatformType.java
//
//   CLIENT_X86(1, "x86"),
//   CLIENT_X64(2, "x64"),
//   SERVER_X86(3, "x86"),
//   SERVER_X64(4, "x64"),
//   CLIENT_ARM64(5, "arm64"),
//   SERVER_ARM64(6, "arm64");

var _ = Describe("Platform Enum", func() {
	It("should have the correct values", func() {
		Expect(platformClientX86).To(BeEquivalentTo(1))
		Expect(platformClientX64).To(BeEquivalentTo(2))
		Expect(platformServerX86).To(BeEquivalentTo(3))
		Expect(platformServerX64).To(BeEquivalentTo(4))
		Expect(platformClientARM64).To(BeEquivalentTo(5))
		Expect(platformServerARM64).To(BeEquivalentTo(6))
	})

	It("should implement stringer interface", func() {
		var _ fmt.Stringer = (*platformEnum)(nil)
	})

	It("should return cbd strings from string func", func() {
		Expect(platformClientX86.String()).To(Equal("x86"))
		Expect(platformClientX64.String()).To(Equal("x64"))
		Expect(platformServerX86.String()).To(Equal("x86"))
		Expect(platformServerX64.String()).To(Equal("x64"))
		Expect(platformClientARM64.String()).To(Equal("arm64"))
		Expect(platformServerARM64.String()).To(Equal("arm64"))
		Expect(platformEnum(0).String()).To(Equal(""))
	})
})
