package model

type sensorKitEnum int

const (
	sensorKitXP      sensorKitEnum = iota + 1 // 1; Windows XP
	sensorKitWindows                          // 2; Windows 7, 8 and Vista
	sensorKitAndroid                          // 3; Android
	sensorKitMac                              // 4; Mac OS/X/11
	sensorKitIOS                              // 5; IOS
	_                                         // 6; unused
	sensorKitAVSig                            // 7; Av
	_                                         // 8; unused
	_                                         // 9; unused
	sensorKitOther                            // 10; Other
)

const (
	sensorKitRHEL        sensorKitEnum = iota + 100 // 100; RHEL
	sensorKitUbuntu                                 // 101; Ubuntu
	sensorKitSUSE                                   // 102; SUSE
	sensorKitAmazonLinux                            // 103; Amazon Linux
	sensorKitGoogleLinux                            // 104; Google Linux (Container-Optimized OS)
)

const (
	sensorKitMacOSX sensorKitEnum = iota + 901 // 901; Mac OSX for UI
)

//nolint:cyclop // high score, easy grok
func (ske sensorKitEnum) String() string {
	switch ske {
	case sensorKitXP:
		return "XP"
	case sensorKitWindows:
		return "WINDOWS"
	case sensorKitAndroid:
		return "ANDROID"
	case sensorKitMac:
		return "MAC"
	case sensorKitIOS:
		return "IOS"
	case sensorKitAVSig:
		return "AV_SIG"
	case sensorKitOther:
		return "OTHER"
	case sensorKitRHEL:
		return "RHEL"
	case sensorKitUbuntu:
		return "UBUNTU"
	case sensorKitSUSE:
		return "SUSE"
	case sensorKitAmazonLinux:
		return "AMAZON_LINUX"
	case sensorKitGoogleLinux:
		return "GOOGLE_LINUX"
	case sensorKitMacOSX:
		return "MAC_OSX"
	default:
		return "UNKNOWN"
	}
}
