//nolint:testpackage // testing internal enum
package model

import (
	"fmt"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
)

//nolint:lll // long url, sorry
// From https://gitlab.bit9.local/cb-defense/cbd/-/blob/main/backend/domainModel/src/main/java/com/scargo/domainmodel/request/support/SensorKitType.java
//
//   XP(1),
//   WINDOWS(2),
//   ANDROID(3),
//   MAC(4),
//   IOS(5),
//   AV_SIG(7),
//   OTHER(10),
//   RHEL(100),
//   UBUNTU(101),
//   SUSE(102),
//   AMAZON_LINUX(103),
//   GOOGLE_LINUX(104),
//   MAC_OSX(901);

var _ = Describe("Sensor Kit Enum", func() {
	It("should be a stringer", func() {
		var _ fmt.Stringer = (*sensorKitEnum)(nil)
	})

	It("should return the cbd strings from string func", func() {
		Expect(sensorKitXP.String()).To(Equal("XP"))
		Expect(sensorKitWindows.String()).To(Equal("WINDOWS"))
		Expect(sensorKitAndroid.String()).To(Equal("ANDROID"))
		Expect(sensorKitMac.String()).To(Equal("MAC"))
		Expect(sensorKitIOS.String()).To(Equal("IOS"))
		Expect(sensorKitAVSig.String()).To(Equal("AV_SIG"))
		Expect(sensorKitOther.String()).To(Equal("OTHER"))
		Expect(sensorKitRHEL.String()).To(Equal("RHEL"))
		Expect(sensorKitUbuntu.String()).To(Equal("UBUNTU"))
		Expect(sensorKitSUSE.String()).To(Equal("SUSE"))
		Expect(sensorKitAmazonLinux.String()).To(Equal("AMAZON_LINUX"))
		Expect(sensorKitGoogleLinux.String()).To(Equal("GOOGLE_LINUX"))
		Expect(sensorKitMacOSX.String()).To(Equal("MAC_OSX"))
		Expect(sensorKitEnum(-1).String()).To(Equal("UNKNOWN"))
	})

	It("should have the cbd values", func() {
		Expect(sensorKitXP).To(BeEquivalentTo(1))
		Expect(sensorKitWindows).To(BeEquivalentTo(2))
		Expect(sensorKitAndroid).To(BeEquivalentTo(3))
		Expect(sensorKitMac).To(BeEquivalentTo(4))
		Expect(sensorKitIOS).To(BeEquivalentTo(5))
		Expect(sensorKitAVSig).To(BeEquivalentTo(7))
		Expect(sensorKitOther).To(BeEquivalentTo(10))
		Expect(sensorKitRHEL).To(BeEquivalentTo(100))
		Expect(sensorKitUbuntu).To(BeEquivalentTo(101))
		Expect(sensorKitSUSE).To(BeEquivalentTo(102))
		Expect(sensorKitAmazonLinux).To(BeEquivalentTo(103))
		Expect(sensorKitGoogleLinux).To(BeEquivalentTo(104))
		Expect(sensorKitMacOSX).To(BeEquivalentTo(901))
	})
})
