package service_test

import (
	"os"
	"testing"

	"gitlab.bit9.local/psc/platform/ems/device-service/internal/service"

	"github.com/golang/mock/gomock"
	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	"github.com/rs/zerolog"
)

//nolint:gochecknoglobals // singleton test controller
var ctrl *gomock.Controller

func TestService(t *testing.T) {
	ctrl = gomock.NewController(t)
	t.Parallel()
	RegisterFailHandler(Fail)
	RunSpecs(t, "Service")
}

var _ = Describe("Service", func() {
	var svc service.Performer
	var logger zerolog.Logger

	Context("New method", func() {
		BeforeEach(func() {
			logger = zerolog.New(os.Stdout)
			svc = service.New()
		})

		It("should return new service", func() {
			Expect(svc).ToNot(BeNil())
		})

		Context("Perform method", func() {
			It("should not error", func() {
				err := svc.Perform(&logger)
				Expect(err).To(BeNil())
			})
		})
	})
})
