package telemetry

import (
	"github.com/wavefronthq/wavefront-sdk-go/event"
	"github.com/wavefronthq/wavefront-sdk-go/histogram"
	"github.com/wavefronthq/wavefront-sdk-go/senders"
)

// Verify `NoopSender` struct's `senders.Sender` interface compliance.
var _ senders.Sender = (*NoopSender)(nil)

type NoopSender struct{}

func (n NoopSender) SendMetric(_ string, _ float64, _ int64, _ string, _ map[string]string) error {
	return nil
}

func (n NoopSender) SendDeltaCounter(_ string, _ float64, _ string, _ map[string]string) error {
	return nil
}

func (n NoopSender) SendDistribution(
	_ string,
	_ []histogram.Centroid,
	_ map[histogram.Granularity]bool,
	_ int64,
	_ string,
	_ map[string]string,
) error {
	return nil
}

func (n NoopSender) SendSpan(
	_ string,
	_,
	_ int64,
	_,
	_,
	_ string,
	_,
	_ []string,
	_ []senders.SpanTag,
	_ []senders.SpanLog,
) error {
	return nil
}

func (n NoopSender) SendEvent(
	_ string,
	_,
	_ int64,
	_ string,
	_ map[string]string,
	_ ...event.Option,
) error {
	return nil
}

func (n NoopSender) Flush() error {
	return nil
}

func (n NoopSender) GetFailureCount() int64 {
	return 0
}

func (n NoopSender) Start() {}

func (n NoopSender) Close() {}
