package telemetry_test

import (
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/config"
	"gitlab.bit9.local/psc/platform/ems/device-service/internal/telemetry"

	. "github.com/onsi/ginkgo"
	. "github.com/onsi/gomega"
	"github.com/opentracing/opentracing-go"
	"github.com/spf13/viper"
	"google.golang.org/grpc/metadata"
)

var _ = Describe("Tracing", func() {
	It("should create a tracer", func() {
		viper.SetDefault(config.WFSamplerRateKey, 25)
		viper.SetDefault(config.TracingEnabledKey, true)

		telemetry.SetupTracing(nil)

		tracer := opentracing.GlobalTracer()
		Expect(tracer).NotTo(BeNil())
	})

	It("should extract a span from gRPC metadata again", func() {
		md := metadata.New(map[string]string{
			":authority":    "ems-device-service:5004",
			"content-type":  "application/grpc",
			"user-agent":    "grpc-go/1.55.0",
			"wf-ot-sample":  "true",
			"wf-ot-spanid":  "66e4e774-fef4-5ceb-f125-5cb372ded8fc",
			"wf-ot-traceid": "eba8b123-04f2-92e2-a29e-c586af2eb4ab",
		})

		spanCtx := telemetry.SpanContextFromGRPC(md)

		Expect(spanCtx).ToNot(BeNil())
	})
})
